pcl::ExtractIndices< pcl::PCLPointCloud2 > Class Template Reference
Module filters

ExtractIndices extracts a set of indices from a point cloud. More...

`#include <pcl/filters/extract_indices.h>`

Inheritance diagram for pcl::ExtractIndices< pcl::PCLPointCloud2 >:

## Public Types

typedef pcl::PCLPointCloud2 | PCLPointCloud2
typedef PCLPointCloud2::Ptr | PCLPointCloud2Ptr
typedef PCLPointCloud2::ConstPtr | PCLPointCloud2ConstPtr
Public Types inherited from pcl::FilterIndices< pcl::PCLPointCloud2 >
typedef pcl::PCLPointCloud2 | PCLPointCloud2
Public Types inherited from pcl::Filter< pcl::PCLPointCloud2 >
typedef boost::shared_ptr< Filter< pcl::PCLPointCloud2 > > | Ptr
typedef boost::shared_ptr< const Filter< pcl::PCLPointCloud2 > > | ConstPtr
typedef pcl::PCLPointCloud2 | PCLPointCloud2
typedef PCLPointCloud2::Ptr | PCLPointCloud2Ptr
typedef PCLPointCloud2::ConstPtr | PCLPointCloud2ConstPtr
Public Types inherited from pcl::PCLBase< pcl::PCLPointCloud2 >
typedef pcl::PCLPointCloud2 | PCLPointCloud2
typedef boost::shared_ptr< PCLPointCloud2 > | PCLPointCloud2Ptr
typedef boost::shared_ptr< PCLPointCloud2 const > | PCLPointCloud2ConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| ExtractIndices ()
| Empty constructor. More...
Public Member Functions inherited from pcl::FilterIndices< pcl::PCLPointCloud2 >
| FilterIndices (bool extract_removed_indices=false)
| Constructor. More...
virtual | ~FilterIndices ()
| Empty virtual destructor. More...
virtual void | filter (PCLPointCloud2 &output)
void | filter (std::vector< int > &indices)
| Calls the filtering method and returns the filtered point cloud indices. More...
void | setNegative (bool negative)
| Set whether the regular conditions for points filtering should apply, or the inverted conditions. More...
bool | getNegative ()
| Get whether the regular conditions for points filtering should apply, or the inverted conditions. More...
void | setKeepOrganized (bool keep_organized)
| Set whether the filtered points should be kept and set to the value given through setUserFilterValue (default: NaN), or removed from the PointCloud, thus potentially breaking its organized structure. More...
bool | getKeepOrganized ()
| Get whether the filtered points should be kept and set to the value given through setUserFilterValue (default = NaN), or removed from the PointCloud, thus potentially breaking its organized structure. More...
void | setUserFilterValue (float value)
| Provide a value that the filtered points should be set to instead of removing them. More...
Public Member Functions inherited from pcl::Filter< pcl::PCLPointCloud2 >
| Filter (bool extract_removed_indices=false)
| Empty constructor. More...
virtual | ~Filter ()
| Empty destructor. More...
IndicesConstPtr const | getRemovedIndices ()
| Get the point indices being removed. More...
void | getRemovedIndices (PointIndices &pi)
| Get the point indices being removed. More...
void | filter (PCLPointCloud2 &output)
| Calls the filtering method and returns the filtered dataset in output. More...
Public Member Functions inherited from pcl::PCLBase< pcl::PCLPointCloud2 >
| PCLBase ()
| Empty constructor. More...
virtual | ~PCLBase ()
| destructor. More...
void | setInputCloud (const PCLPointCloud2ConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PCLPointCloud2ConstPtr const | getInputCloud ()
| Get a pointer to the input point cloud dataset. More...
void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...

## Protected Member Functions

void | applyFilter (PCLPointCloud2 &output)
| Extract point indices into a separate PointCloud. More...
void | applyFilter (std::vector< int > &indices)
| Extract point indices. More...
Protected Member Functions inherited from pcl::Filter< pcl::PCLPointCloud2 >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
Protected Member Functions inherited from pcl::PCLBase< pcl::PCLPointCloud2 >
bool | initCompute ()
bool | deinitCompute ()

## Additional Inherited Members

Protected Attributes inherited from pcl::FilterIndices< pcl::PCLPointCloud2 >
bool | negative_
| False = normal filter behavior (default), true = inverted behavior. More...
bool | keep_organized_
| False = remove points (default), true = redefine points, keep structure. More...
float | user_filter_value_
| The user given value that the filtered point dimensions should be set to (default = NaN). More...
Protected Attributes inherited from pcl::Filter< pcl::PCLPointCloud2 >
IndicesPtr | removed_indices_
| Indices of the points that are removed. More...
bool | extract_removed_indices_
| Set to true if we want to return the indices of the removed points. More...
std::string | filter_name_
| The filter name. More...
Protected Attributes inherited from pcl::PCLBase< pcl::PCLPointCloud2 >
PCLPointCloud2ConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...
std::vector< int > | field_sizes_
| The size of each individual field. More...
int | x_idx_
| The x-y-z fields indices. More...
int | y_idx_
int | z_idx_
std::string | x_field_name_
| The desired x-y-z field names. More...
std::string | y_field_name_
std::string | z_field_name_

## Detailed Description

### template<>
class pcl::ExtractIndices< pcl::PCLPointCloud2 >

ExtractIndices extracts a set of indices from a point cloud.

Usage examples:

pcl::ExtractIndices<PointType> filter;
filter.setInputCloud (cloud_in);
filter.setIndices (indices_in);
// Extract the points in cloud_in referenced by indices_in as a separate point cloud:
filter.filter (*cloud_out);
// Retrieve indices to all points in cloud_in except those referenced by indices_in:
filter.setNegative (true);
filter.filter (*indices_out);
// The resulting cloud_out is identical to cloud_in, but all points referenced by indices_in are made NaN:
filter.setNegative (true);
filter.setKeepOrganized (true);
filter.filter (*cloud_out);

Note
  Does not inherently remove NaNs from results, hence the extract_removed_indices_ system is not used.

Author
  Radu Bogdan Rusu

Definition at line 161 of file extract_indices.h.

## Member Typedef Documentation

## PCLPointCloud2

typedef pcl::PCLPointCloud2 pcl::ExtractIndices< pcl::PCLPointCloud2 >::PCLPointCloud2

Definition at line 164 of file extract_indices.h.

## PCLPointCloud2ConstPtr

typedef PCLPointCloud2::ConstPtr pcl::ExtractIndices< pcl::PCLPointCloud2 >::PCLPointCloud2ConstPtr

Definition at line 166 of file extract_indices.h.

## PCLPointCloud2Ptr

typedef PCLPointCloud2::Ptr pcl::ExtractIndices< pcl::PCLPointCloud2 >::PCLPointCloud2Ptr

Definition at line 165 of file extract_indices.h.

## Constructor & Destructor Documentation

## ExtractIndices()

pcl::ExtractIndices< pcl::PCLPointCloud2 >::ExtractIndices | ( |  | ) |

inline

Empty constructor.

Definition at line 169 of file extract_indices.h.

References pcl::ExtractIndices< PointT >::applyFilter(), pcl::Filter< PointT >::filter_name_, and pcl::PCLBase< PointT >::use_indices_.

## Member Function Documentation

## applyFilter() [1/2]

void pcl::ExtractIndices< pcl::PCLPointCloud2 >::applyFilter | ( | PCLPointCloud2 & | output | ) |

protected virtual

Extract point indices into a separate PointCloud.

Parameters

  [out] | output | the resultant point cloud

Implements pcl::FilterIndices< pcl::PCLPointCloud2 >.

## applyFilter() [2/2]

void pcl::ExtractIndices< pcl::PCLPointCloud2 >::applyFilter | ( | std::vector< int > & | indices | ) |

protected virtual

Extract point indices.

Parameters

  indices | the resultant indices

Implements pcl::FilterIndices< pcl::PCLPointCloud2 >.

The documentation for this class was generated from the following file:

- /build/pcl-OilVEB/pcl-1.8.1+dfsg1/filters/include/pcl/filters/extract_indices.h